﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CameraManager : MonoBehaviour
{
    // Public variables
    public List<Camera> cameras;
    public int currentCameraIndex;

    // Use this for initialization
    void Start ()
    {
        // Make the currentCameraIndex 0
        currentCameraIndex = 0;
        // Loop through each camera and disable them and perform offset calculations
        for (int i = 1; i < cameras.Count; i++)
        {
            cameras[i].gameObject.SetActive(false);
        }
        // If any cameras were added to the controller, enable the first one
        if (cameras.Count > 0)
        {
            cameras[0].gameObject.SetActive(true);
            GetComponent<UnderwaterEffectControl>().SetNormalFogValues();
        }
    }
	
	// Update is called once per frame
	void Update ()
    {
        // Check if the user pressed the 'C' key
        if (Input.GetKeyDown(KeyCode.C))
        {
            // Cycle to the next camera
            currentCameraIndex++;
            // Check to make sure the cameraIndex is within bounds of the cameras list
            if (currentCameraIndex < cameras.Count)
            {
                // Set the camera at the previous index inactive
                cameras[currentCameraIndex - 1].gameObject.SetActive(false);
                // Set the camera at the current index active
                cameras[currentCameraIndex].gameObject.SetActive(true);
            }
            // Otherwise, if the cameraIndex is out of the bounds of the cameras list, cycle back to first camera
            else
            {
                // Set the camera at the previous index inactive
                cameras[currentCameraIndex - 1].gameObject.SetActive(false);
                // Reset the cameraIndex back to 0
                currentCameraIndex = 0;
                // Set the camera at the current index active
                cameras[currentCameraIndex].gameObject.SetActive(true);
                //GetComponent<UnderwaterEffectControl>().SetNormalFogValues();
                //RenderSettings.fog = false;
            }
        }
        if (currentCameraIndex == 0 && (RenderSettings.fogColor != GetComponent<UnderwaterEffectControl>().defaultFogColor))
        {
            RenderSettings.fog = false;
            GetComponent<UnderwaterEffectControl>().SetNormalFogValues();
        }
    }
}
