﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

/* Author: Andrew Brook
 * Class: IGME 202-02
 * Instructor: Jay Alan Jackson
 * Purpose of Class: Utilizes fog rendering settings to give an underwater look to the game when the camera is submerged
 */
public class UnderwaterEffectControl : MonoBehaviour
{
    public Transform waterPlane;
    // Underwater stuff
    public bool isUnderwater;
    public Color underwaterFogColor = new Color(0.22f, 0.65f, 0.77f, 0.5f);
    public float underwaterFogDensity = 0.1f;

    public Color defaultFogColor;
    private float defaultFogDensity;
    // Use this for initialization
    void Start ()
    {
        isUnderwater = false;
        defaultFogColor = RenderSettings.fogColor;
        defaultFogDensity = RenderSettings.fogDensity;
    }
	
	// Update is called once per frame
	void Update ()
    {
        if (Camera.main.transform.position.y < waterPlane.transform.position.y)
        {
            if (isUnderwater != true)
            {
                isUnderwater = true;
                if (RenderSettings.fog == false) RenderSettings.fog = true;
                SetUnderwaterFogValues();
            }
        }
        else
        {
            if (isUnderwater != false)
            {
                isUnderwater = false;
                SetNormalFogValues();
            }
        }
    }

    public void SetNormalFogValues()
    {
        RenderSettings.fogColor = defaultFogColor;
        RenderSettings.fogDensity = defaultFogDensity;
        RenderSettings.fog = false;
    }

    private void SetUnderwaterFogValues()
    {
        if (GetComponent<CameraManager>().currentCameraIndex != 0)
        {
            RenderSettings.fog = true;
            RenderSettings.fogColor = underwaterFogColor;
            RenderSettings.fogDensity = underwaterFogDensity;
        }
    }
}
